var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import Ky from 'ky-universal';
import { decamelizeKeys } from 'humps';
import { stringify } from 'query-string';
import { skipAllCaps } from './Utils';
var methods = ['get', 'post', 'put', 'delete'];
var KyRequester = {};
function responseHeadersAsObject(response) {
    var headers = {};
    var keyVals = __spread(response.headers.entries());
    keyVals.forEach(function (_a) {
        var _b = __read(_a, 2), key = _b[0], val = _b[1];
        headers[key] = val;
    });
    return headers;
}
function defaultRequest(service, endpoint, _a) {
    var body = _a.body, query = _a.query, sudo = _a.sudo;
    var headers = new Headers(service.headers);
    if (sudo)
        headers.append('sudo', "" + sudo);
    return [
        endpoint,
        {
            timeout: 30000,
            headers: headers,
            searchParams: stringify(decamelizeKeys(query || {}), { arrayFormat: 'bracket' }),
            prefixUrl: service.url,
            json: typeof body === 'object' ? decamelizeKeys(body, skipAllCaps) : body,
            rejectUnauthorized: service.rejectUnauthorized,
        },
    ];
}
methods.forEach(function (m) {
    KyRequester[m] = function (service, endpoint, options) {
        return __awaiter(this, void 0, void 0, function () {
            var response, status_1, headers, body, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, Ky[m].apply(Ky, __spread(defaultRequest(service, endpoint, options)))];
                    case 1:
                        response = _a.sent();
                        status_1 = response.status;
                        headers = responseHeadersAsObject(response);
                        return [4 /*yield*/, response.json()];
                    case 2:
                        body = _a.sent();
                        if (typeof body === 'object')
                            body = body || {};
                        return [2 /*return*/, { body: body, headers: headers, status: status_1 }];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1);
                        console.error.apply(console, __spread(defaultRequest(service, endpoint, options)));
                        throw e_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
});
export { KyRequester };
