var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import Li from 'li';
import { camelizeKeys } from 'humps';
export function get(service, endpoint, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var showPagination, maxPages, sudo, query, response, headers, body, pagination, underLimit, next, more;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    showPagination = options.showPagination, maxPages = options.maxPages, sudo = options.sudo, query = __rest(options, ["showPagination", "maxPages", "sudo"]);
                    return [4 /*yield*/, service.requester.get(service, endpoint, {
                            query: query || {},
                            sudo: sudo,
                        })];
                case 1:
                    response = _a.sent();
                    headers = response.headers;
                    body = response.body;
                    pagination = {
                        total: headers['x-total'],
                        next: parseInt(headers['x-next-page'], 10) || null,
                        current: parseInt(headers['x-page'], 10) || 1,
                        previous: headers['x-prev-page'] || null,
                        perPage: headers['x-per-page'],
                        totalPages: headers['x-total-pages'],
                    };
                    underLimit = maxPages ? pagination.current < maxPages : true;
                    // Camelize response body if specified
                    if (service.camelize)
                        body = camelizeKeys(body);
                    if (!(!query.page && underLimit && pagination.next)) return [3 /*break*/, 3];
                    next = Li.parse(headers.link).next;
                    return [4 /*yield*/, get(service, next.replace(/.+\/api\/v\d\//, ''), {
                            maxPages: maxPages,
                            sudo: sudo,
                            showPagination: true
                        })];
                case 2:
                    more = _a.sent();
                    pagination = more.pagination;
                    body = __spread(body, more.data);
                    _a.label = 3;
                case 3: return [2 /*return*/, (query.page || body.length > 0) && showPagination ? { data: body, pagination: pagination } : body];
            }
        });
    });
}
export function stream(service, endpoint, options) {
    if (options === void 0) { options = {}; }
    if (typeof service.requester.stream !== 'function') {
        throw new Error('Stream method is not implementated in requester!');
    }
    return service.requester.stream(service, endpoint, {
        query: options,
    });
}
export function post(service, endpoint, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var sudo, body, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sudo = options.sudo, body = __rest(options, ["sudo"]);
                    return [4 /*yield*/, service.requester.post(service, endpoint, {
                            body: body,
                            sudo: sudo,
                        })];
                case 1:
                    response = _a.sent();
                    return [2 /*return*/, response.body];
            }
        });
    });
}
export function put(service, endpoint, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var sudo, body, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sudo = options.sudo, body = __rest(options, ["sudo"]);
                    return [4 /*yield*/, service.requester.put(service, endpoint, {
                            body: body,
                        })];
                case 1:
                    response = _a.sent();
                    return [2 /*return*/, response.body];
            }
        });
    });
}
export function del(service, endpoint, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var sudo, query, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sudo = options.sudo, query = __rest(options, ["sudo"]);
                    return [4 /*yield*/, service.requester.delete(service, endpoint, {
                            query: query,
                            sudo: sudo,
                        })];
                case 1:
                    response = _a.sent();
                    return [2 /*return*/, response.body];
            }
        });
    });
}
