var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { BaseService, RequestHelper } from '../infrastructure';
var Groups = /** @class */ (function (_super) {
    __extends(Groups, _super);
    function Groups() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Groups.prototype.all = function (options) {
        return RequestHelper.get(this, 'groups', options);
    };
    Groups.prototype.create = function (options) {
        return RequestHelper.post(this, 'groups', options);
    };
    Groups.prototype.createLDAPLink = function (groupId, cn, groupAccess, provider, options) {
        var gId = encodeURIComponent(groupId);
        return RequestHelper.post(this, "groups/" + gId + "/ldap_group_links", __assign({ cn: cn,
            groupAccess: groupAccess,
            provider: provider }, options));
    };
    Groups.prototype.edit = function (groupId, options) {
        var gId = encodeURIComponent(groupId);
        return RequestHelper.put(this, "groups/" + gId, options);
    };
    Groups.prototype.remove = function (groupId, options) {
        var gId = encodeURIComponent(groupId);
        return RequestHelper.del(this, "groups/" + gId, options);
    };
    Groups.prototype.removeLDAPLink = function (groupId, cn, _a) {
        if (_a === void 0) { _a = {}; }
        var provider = _a.provider, options = __rest(_a, ["provider"]);
        var gId = encodeURIComponent(groupId);
        var url = provider ? provider + "/" + cn : "" + cn;
        return RequestHelper.del(this, "groups/" + gId + "/ldap_group_links/" + url, options);
    };
    Groups.prototype.search = function (nameOrPath, options) {
        return RequestHelper.get(this, 'groups', __assign({ search: nameOrPath }, options));
    };
    Groups.prototype.show = function (groupId, options) {
        var gId = encodeURIComponent(groupId);
        return RequestHelper.get(this, "groups/" + gId, options);
    };
    Groups.prototype.subgroups = function (groupId, options) {
        var gId = encodeURIComponent(groupId);
        return RequestHelper.get(this, "groups/" + gId + "/subgroups", options);
    };
    Groups.prototype.syncLDAP = function (groupId, options) {
        var gId = encodeURIComponent(groupId);
        return RequestHelper.post(this, "groups/" + gId + "/ldap_sync", options);
    };
    return Groups;
}(BaseService));
export default Groups;
