var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { BaseService, RequestHelper } from '../infrastructure';
var Issues = /** @class */ (function (_super) {
    __extends(Issues, _super);
    function Issues() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Issues.prototype.addSpentTime = function (projectId, issueId, duration, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/issues/" + iId + "/add_spent_time", __assign({ duration: duration }, options));
    };
    Issues.prototype.addTimeEstimate = function (projectId, issueId, duration, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/issues/" + iId + "/time_estimate", __assign({ duration: duration }, options));
    };
    Issues.prototype.all = function (_a) {
        if (_a === void 0) { _a = {}; }
        var projectId = _a.projectId, options = __rest(_a, ["projectId"]);
        var url = projectId ? "projects/" + encodeURIComponent(projectId) + "/issues" : 'issues';
        return RequestHelper.get(this, url, options);
    };
    Issues.prototype.create = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/issues", options);
    };
    Issues.prototype.edit = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.put(this, "projects/" + pId + "/issues/" + iId, options);
    };
    Issues.prototype.link = function (projectId, issueIId, targetProjectId, targetIssueId, options) {
        var _a = __read([projectId, issueIId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        var _b = __read([targetProjectId, targetIssueId].map(encodeURIComponent), 2), targetpId = _b[0], targetIId = _b[1];
        return RequestHelper.post(this, "projects/" + pId + "/issues/" + iId + "/links", __assign({ targetProjectId: targetpId, targetIssueId: targetIId }, options));
    };
    Issues.prototype.participants = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/issues/" + iId + "/participants", options);
    };
    Issues.prototype.remove = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.del(this, "projects/" + pId + "/issues/" + iId, options);
    };
    Issues.prototype.resetSpentTime = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/issues/" + iId + "/reset_spent_time", options);
    };
    Issues.prototype.resetTimeEstimate = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/issues/" + iId + "/reset_time_estimate", options);
    };
    Issues.prototype.show = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/issues/" + iId, options);
    };
    Issues.prototype.subscribe = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/issues/" + iId + "/subscribe", options);
    };
    Issues.prototype.timeStats = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/issues/" + iId + "/time_stats", options);
    };
    Issues.prototype.unsubscribe = function (projectId, issueId, options) {
        var _a = __read([projectId, issueId].map(encodeURIComponent), 2), pId = _a[0], iId = _a[1];
        return RequestHelper.del(this, "projects/" + pId + "/issues/" + iId + "/unsubscribe", options);
    };
    return Issues;
}(BaseService));
export default Issues;
