var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { BaseService, RequestHelper } from '../infrastructure';
var MergeRequests = /** @class */ (function (_super) {
    __extends(MergeRequests, _super);
    function MergeRequests() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MergeRequests.prototype.accept = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.put(this, "projects/" + pId + "/merge_requests/" + mIId + "/merge", options);
    };
    MergeRequests.prototype.addSpentTime = function (projectId, mergerequestIId, duration, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests/" + mIId + "/add_spent_time", __assign({ duration: duration }, options));
    };
    MergeRequests.prototype.addTimeEstimate = function (projectId, mergerequestIId, duration, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests/" + mIId + "/time_estimate", __assign({ duration: duration }, options));
    };
    MergeRequests.prototype.all = function (_a) {
        var projectId = _a.projectId, groupId = _a.groupId, options = __rest(_a, ["projectId", "groupId"]);
        var url;
        if (projectId) {
            url = "projects/" + encodeURIComponent(projectId) + "/merge_requests";
        }
        else if (groupId) {
            url = "groups/" + encodeURIComponent(groupId) + "/merge_requests";
        }
        else {
            url = 'merge_requests';
        }
        return RequestHelper.get(this, url, options);
    };
    MergeRequests.prototype.approve = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests/" + mIId + "/approve", options);
    };
    MergeRequests.prototype.approvals = function (projectId, _a) {
        var mergerequestIId = _a.mergerequestIId, options = __rest(_a, ["mergerequestIId"]);
        var _b = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _b[0], mIId = _b[1];
        var url;
        if (mergerequestIId) {
            url = "projects/" + pId + "/merge_requests/" + mIId + "/approvals";
        }
        else {
            url = "projects/" + pId + "/approvals";
        }
        return RequestHelper.get(this, url, options);
    };
    MergeRequests.prototype.approvers = function (projectId, approverIds, approverGroupIds, _a) {
        var mergerequestIId = _a.mergerequestIId, options = __rest(_a, ["mergerequestIId"]);
        var _b = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _b[0], mIId = _b[1];
        var url;
        if (mergerequestIId) {
            url = "projects/" + pId + "/merge_requests/" + mIId + "/approvers";
        }
        else {
            url = "projects/" + pId + "/approvers";
        }
        return RequestHelper.put(this, url, __assign({ approverIds: approverIds, approverGroupIds: approverGroupIds }, options));
    };
    MergeRequests.prototype.cancelOnPipelineSucess = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.put(this, "projects/" + pId + "/merge_requests/" + mIId + "/cancel_merge_when_pipeline_succeeds", options);
    };
    MergeRequests.prototype.changes = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/changes", options);
    };
    MergeRequests.prototype.closesIssues = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/closes_issues", options);
    };
    MergeRequests.prototype.commits = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/commits", options);
    };
    MergeRequests.prototype.create = function (projectId, sourceBranch, targetBranch, title, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests", __assign({ id: pId, sourceBranch: sourceBranch,
            targetBranch: targetBranch,
            title: title }, options));
    };
    MergeRequests.prototype.edit = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.put(this, "projects/" + pId + "/merge_requests/" + mIId, options);
    };
    MergeRequests.prototype.editApprovals = function (projectId, _a) {
        var mergerequestIId = _a.mergerequestIId, options = __rest(_a, ["mergerequestIId"]);
        var _b = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _b[0], mIId = _b[1];
        var url;
        if (mergerequestIId) {
            url = "projects/" + pId + "/merge_requests/" + mIId + "/approvals";
        }
        else {
            url = "projects/" + pId + "/approvals";
        }
        return RequestHelper.post(this, url, options);
    };
    MergeRequests.prototype.participants = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/participants", options);
    };
    MergeRequests.prototype.pipelines = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/pipelines", options);
    };
    MergeRequests.prototype.remove = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.del(this, "projects/" + pId + "/merge_requests/" + mIId, options);
    };
    MergeRequests.prototype.resetSpentTime = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests/" + mIId + "/reset_spent_time", options);
    };
    MergeRequests.prototype.resetTimeEstimate = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests/" + mIId + "/reset_time_estimate", options);
    };
    MergeRequests.prototype.show = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId, options);
    };
    MergeRequests.prototype.timeStats = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/time_stats", options);
    };
    MergeRequests.prototype.version = function (projectId, mergerequestIId, versionId, options) {
        var _a = __read([projectId, mergerequestIId, versionId].map(encodeURIComponent), 3), pId = _a[0], mIId = _a[1], vId = _a[2];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/versions/" + vId, options);
    };
    MergeRequests.prototype.versions = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.get(this, "projects/" + pId + "/merge_requests/" + mIId + "/versions", options);
    };
    MergeRequests.prototype.unapprove = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/merge_requests/" + mIId + "/approve", options);
    };
    MergeRequests.prototype.unsubscribe = function (projectId, mergerequestIId, options) {
        var _a = __read([projectId, mergerequestIId].map(encodeURIComponent), 2), pId = _a[0], mIId = _a[1];
        return RequestHelper.del(this, "projects/" + pId + "/merge_requests/" + mIId + "/unsubscribe", options);
    };
    return MergeRequests;
}(BaseService));
export default MergeRequests;
