var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import FormData from 'form-data';
import randomstring from 'randomstring';
import { BaseService, RequestHelper } from '../infrastructure';
var Projects = /** @class */ (function (_super) {
    __extends(Projects, _super);
    function Projects() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Projects.prototype.all = function (options) {
        return RequestHelper.get(this, 'projects', options);
    };
    Projects.prototype.archive = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/archive", options);
    };
    Projects.prototype.create = function (_a) {
        var userId = _a.userId, options = __rest(_a, ["userId"]);
        var url = userId ? "projects/user/" + encodeURIComponent(userId) : 'projects';
        return RequestHelper.post(this, url, options);
    };
    Projects.prototype.edit = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.put(this, "projects/" + pId, options);
    };
    Projects.prototype.events = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.get(this, "projects/" + pId + "/events", options);
    };
    Projects.prototype.fork = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/fork", options);
    };
    Projects.prototype.forks = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.get(this, "projects/" + pId + "/forks", options);
    };
    Projects.prototype.languages = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.get(this, "projects/" + pId + "/languages", options);
    };
    Projects.prototype.mirrorPull = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/mirror/pull", options);
    };
    Projects.prototype.remove = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.del(this, "projects/" + pId, options);
    };
    Projects.prototype.removeFork = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.del(this, "projects/" + pId + "/fork", options);
    };
    Projects.prototype.search = function (projectName) {
        return RequestHelper.get(this, 'projects', { search: projectName });
    };
    Projects.prototype.share = function (projectId, groupId, groupAccess, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/share", __assign({ groupId: groupId, groupAccess: groupAccess }, options));
    };
    Projects.prototype.show = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.get(this, "projects/" + pId, options);
    };
    Projects.prototype.star = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/star", options);
    };
    Projects.prototype.statuses = function (projectId, sha, state, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/statuses/" + sha, __assign({ state: state }, options));
    };
    Projects.prototype.transfer = function (projectId, namespaceId) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.put(this, "projects/" + pId + "/transfer", { namespace: namespaceId });
    };
    Projects.prototype.unarchive = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/unarchive", options);
    };
    Projects.prototype.unshare = function (projectId, groupId, options) {
        var _a = __read([projectId, groupId].map(encodeURIComponent), 2), pId = _a[0], gId = _a[1];
        return RequestHelper.del(this, "projects/" + pId + "/share/" + gId, options);
    };
    Projects.prototype.unstar = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/unstar", options);
    };
    Projects.prototype.updatePushRule = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.put(this, "projects/" + pId + "/push_rule", options);
    };
    Projects.prototype.upload = function (projectId, content, metadata, options) {
        if (metadata === void 0) { metadata = {}; }
        var pId = encodeURIComponent(projectId);
        var form = new FormData();
        var defaultMetadata = {
            filename: randomstring.generate(8),
            contentType: 'application/octet-stream',
        };
        form.append('file', content, Object.assign(defaultMetadata, metadata));
        return RequestHelper.post(this, "projects/" + pId + "/uploads", __assign({}, options, { form: form }));
    };
    return Projects;
}(BaseService));
export default Projects;
