var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { BaseService, RequestHelper } from '../infrastructure';
var PushRule = /** @class */ (function (_super) {
    __extends(PushRule, _super);
    function PushRule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PushRule.prototype.create = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.post(this, "projects/" + pId + "/push_rule", options);
    };
    PushRule.prototype.edit = function (projectId, _a) {
        var _b = _a.upsert, upsert = _b === void 0 ? false : _b, options = __rest(_a, ["upsert"]);
        var pId = encodeURIComponent(projectId);
        try {
            return RequestHelper.put(this, "projects/" + pId + "/push_rule", options);
        }
        catch (e) {
            if (e.message.includes('exist'))
                return this.create(projectId, options);
            throw e;
        }
    };
    PushRule.prototype.remove = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.del(this, "projects/" + pId + "/push_rule", options);
    };
    PushRule.prototype.show = function (projectId, options) {
        var pId = encodeURIComponent(projectId);
        return RequestHelper.get(this, "projects/" + pId + "/push_rule", options);
    };
    return PushRule;
}(BaseService));
export default PushRule;
