var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { BaseService, RequestHelper } from '../infrastructure';
var Runners = /** @class */ (function (_super) {
    __extends(Runners, _super);
    function Runners() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Runners.prototype.all = function (_a) {
        var projectId = _a.projectId, options = __rest(_a, ["projectId"]);
        var url = projectId ? "projects/" + encodeURIComponent(projectId) + "/runners" : 'runners/all';
        return RequestHelper.get(this, url, options);
    };
    Runners.prototype.allOwned = function (options) {
        return RequestHelper.get(this, 'runners', options);
    };
    Runners.prototype.edit = function (runnerId, options) {
        var rId = encodeURIComponent(runnerId);
        return RequestHelper.put(this, "runners/" + rId, options);
    };
    Runners.prototype.enable = function (projectId, runnerId, options) {
        var _a = __read([projectId, runnerId].map(encodeURIComponent), 2), pId = _a[0], rId = _a[1];
        return RequestHelper.post(this, "projects/" + pId + "/runners", __assign({ runnerId: rId }, options));
    };
    Runners.prototype.disable = function (projectId, runnerId, options) {
        var _a = __read([projectId, runnerId].map(encodeURIComponent), 2), pId = _a[0], rId = _a[1];
        return RequestHelper.del(this, "projects/" + pId + "/runners/" + rId, options);
    };
    Runners.prototype.jobs = function (runnerId, options) {
        var rId = encodeURIComponent(runnerId);
        return RequestHelper.get(this, "runners/" + rId + "/jobs", options);
    };
    Runners.prototype.remove = function (runnerId, options) {
        var rId = encodeURIComponent(runnerId);
        return RequestHelper.del(this, "runners/" + rId, options);
    };
    Runners.prototype.show = function (runnerId, options) {
        var rId = encodeURIComponent(runnerId);
        return RequestHelper.get(this, "runners/" + rId, options);
    };
    return Runners;
}(BaseService));
export default Runners;
