var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { BaseService, RequestHelper } from '../infrastructure';
var Snippets = /** @class */ (function (_super) {
    __extends(Snippets, _super);
    function Snippets() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Snippets.prototype.all = function (_a) {
        var p = _a.public, options = __rest(_a, ["public"]);
        var url = p ? 'snippets/public' : 'snippets';
        return RequestHelper.get(this, url, options);
    };
    Snippets.prototype.content = function (snippetId, options) {
        var sId = encodeURIComponent(snippetId);
        return RequestHelper.get(this, "snippets/" + sId + "/raw", options);
    };
    Snippets.prototype.create = function (title, fileName, content, visibility, options) {
        return RequestHelper.post(this, 'snippets', __assign({ title: title,
            fileName: fileName,
            content: content,
            visibility: visibility }, options));
    };
    Snippets.prototype.edit = function (snippetId, options) {
        var sId = encodeURIComponent(snippetId);
        return RequestHelper.put(this, "snippets/" + sId, options);
    };
    Snippets.prototype.remove = function (snippetId, options) {
        var sId = encodeURIComponent(snippetId);
        return RequestHelper.del(this, "snippets/" + sId, options);
    };
    Snippets.prototype.show = function (snippetId, options) {
        var sId = encodeURIComponent(snippetId);
        return RequestHelper.get(this, "snippets/" + sId, options);
    };
    Snippets.prototype.userAgentDetails = function (snippetId, options) {
        var sId = encodeURIComponent(snippetId);
        return RequestHelper.get(this, "snippets/" + sId + "/user_agent_detail", options);
    };
    return Snippets;
}(BaseService));
export default Snippets;
