var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { BaseService, RequestHelper } from '../infrastructure';
var Users = /** @class */ (function (_super) {
    __extends(Users, _super);
    function Users() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Users.prototype.all = function (options) {
        return RequestHelper.get(this, 'users', options);
    };
    Users.prototype.activities = function (options) {
        return RequestHelper.get(this, 'users/activities', options);
    };
    Users.prototype.projects = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.get(this, "users/" + uId + "/projects", options);
    };
    Users.prototype.block = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.post(this, "users/" + uId + "/block", options);
    };
    Users.prototype.create = function (options) {
        return RequestHelper.post(this, 'users', options);
    };
    Users.prototype.current = function (options) {
        return RequestHelper.get(this, 'user', options);
    };
    Users.prototype.edit = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.put(this, "users/" + uId, options);
    };
    Users.prototype.events = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.get(this, "users/" + uId + "/events", options);
    };
    Users.prototype.session = function (email, password, options) {
        return RequestHelper.post(this, 'session', __assign({ email: email,
            password: password }, options));
    };
    Users.prototype.search = function (emailOrUsername, options) {
        return RequestHelper.get(this, 'users', __assign({ search: emailOrUsername }, options));
    };
    Users.prototype.show = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.get(this, "users/" + uId, options);
    };
    Users.prototype.remove = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.del(this, "users/" + uId, options);
    };
    Users.prototype.unblock = function (userId, options) {
        var uId = encodeURIComponent(userId);
        return RequestHelper.post(this, "users/" + uId + "/unblock", options);
    };
    return Users;
}(BaseService));
export default Users;
