var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { BaseService, RequestHelper } from '../infrastructure';
function url(projectId, resourceType, resourceId, awardId, noteId) {
    var _a = __read([projectId, resourceId].map(encodeURIComponent), 2), pId = _a[0], rId = _a[1];
    var output = [pId, resourceType, rId];
    if (noteId)
        output.push('notes', encodeURIComponent(noteId));
    output.push(encodeURIComponent('award_emoji'));
    if (awardId)
        output.push(encodeURIComponent(awardId));
    return output.join('/');
}
var ResourceAwardsEmojis = /** @class */ (function (_super) {
    __extends(ResourceAwardsEmojis, _super);
    function ResourceAwardsEmojis(resourceType, options) {
        var _this = _super.call(this, __assign({ url: 'projects' }, options)) || this;
        _this.resourceType = resourceType;
        return _this;
    }
    ResourceAwardsEmojis.prototype.all = function (projectId, resourceId, noteId, options) {
        return RequestHelper.get(this, url(projectId, this.resourceType, resourceId, null, noteId), options);
    };
    ResourceAwardsEmojis.prototype.award = function (projectId, resourceId, name, noteId, options) {
        return RequestHelper.post(this, url(projectId, this.resourceType, resourceId, null, noteId), __assign({ name: name }, options));
    };
    ResourceAwardsEmojis.prototype.remove = function (projectId, resourceId, awardId, noteId, options) {
        return RequestHelper.del(this, url(projectId, this.resourceType, resourceId, awardId, noteId), options);
    };
    ResourceAwardsEmojis.prototype.show = function (projectId, resourceId, awardId, noteId, options) {
        return RequestHelper.get(this, url(projectId, this.resourceType, resourceId, awardId, noteId), options);
    };
    return ResourceAwardsEmojis;
}(BaseService));
export default ResourceAwardsEmojis;
